; mk_col,make_col, make_col2 & make_col3
; mk_cols just gets colours
; make_col put colours into window definition

; make_col3 puts colours into appsub defn
; the scheme set up and expected here is:
; the window definition contains the colours as they would be
; bor the system palette.
; if the colour to be configured is the system palette, then we
; essentially don't do anything, except set the system palette for the job
; since the correct colours are already configured
; a check is made, however, whether a system palette is actually possible.
; (by checking (a1) )


	section mk_cols

	xdef	mk_col		; get colours into regs d0-d3
	xdef	make_col	; get colours & set them in a wdw definition
	xdef	make_col2 ; set colours in a wdw definition
	xdef	make_col3 ; get & set colours in an appsub working defn
	include dev1_asm_incl_keys_wman_wwork
	include dev1_asm_incl_keys_syspal
	include dev1_asm_incl_keys_wman

; mk_col: gets colours into d0 - d3 if a colourway is wished
;	  else set syspal if possible, (else sets colourway 0)
; entry 		  exit
; d0				  d0.w paper colour or error if <0 or $1234 if syspal
; d1				  d1.w border/items selected colour
; d2				  d2.w ink colour
; d3				  d3.w menu bar colour
; a1 points to colour code byte   a1	  kept
; a5 PE vector			  stet
; condition codes are set on exit
;
myregs	reg a0-a5

mk_col	movem.l myregs,-(a7)
	clr.l	d0
	move.b	(a1),d0 		; colourway wished
	move.l	d0,d1			; keep
	subq.b	#4,d1			; syspal wished?
	blt.s	old			;   no->....
	cmp.l	#'1.55',(a5)		;   yes, but can this system handle that?
	blt.s	old2			;     ...no - do old colourway

syspal_ok
	move.l	d1,d3			; "true" system palette colourway
	moveq	#-1,d1
	sub.l	a1,a1
	jsr	wm.jbpal(a5)		; set my job palette to this one
	tst.l	d0
	bne.s	mc_out
	move.l	#$1234,d0		; special return
mc_out	movem.l (a7)+,myregs		;
	tst.l	d0
	rts

old2	move.b	#0,(a1) 		; preset colourway 0 !!!!!!
old	moveq	#$10,d0
	moveq	#-1,d1
	moveq	#-1,d2
	trap	#1			; read current colour mode
	tst.l	d0
	bne.s	mkout
	move.b	(a1),d0
	lea	col_data,a1
	cmp.b	#2,d1
	bne.s	no_mono
	lea	col_data2,a1
no_mono lsl.w	#3,d0			; *8 (8 bytes per colour)
	add.w	d0,a1			; point to data corresponding to code
	moveq	#0,d0			; set condition codes
	movem.w (a1)+,d0-d3		; get colours into regs d0 to d3
mkout	movem.l (a7)+,myregs
	tst.l	d0
	rts
col_data
	dc.w	  7,4,0,92		; white/green: paper, border, ink, menu
	dc.w	  0,2,7,82		; black red
	dc.w	  7,2,0,107		; white/red
	dc.w	  0,4,7,100		; black/green
col_data2				; for monochrome screens
	dc.w	  7,0,0,82		; white/green: paper, ink, inverse, menu
	dc.w	  0,7,7,82		; black red
	dc.w	  7,0,0,107		; white/red
	dc.w	  0,7,7,100		; black/green


; make_col and make_col2: these routines change a window definition so
; that the colours correspond to a colour code
; make_col gets the colour information first
; make_col2 presumes that it is
; already in d0-d3
; make_col

; on entry:					   exit
; d4 = bitmap: number(s) of wdw with title bar	preserved
; a1 = pointer to byte where colour code is *	preserved
; a3 = window definition			preserved
; a5 = wman vector base 			preserved
; all regs preserved, condition codes set on exit
;
; colour codes are:
; 0 - 3 colourways 0 to 3
; 4 - 7 system palettes 0 to 3
; -1 use the menu extensions default colourway not implemented here


myregs2  reg	 d1-d6/a0/a1/a3


make_col bsr	mk_col			; make/set colours
	tst.l	d0			; OK ?
	blt.s	mk_rts			; no!
	cmp.l	#$1234,d0		; syspal?
	bne.s	comm			; no, old colours
mk_rts	rts



; make_col2
; this is only useful for colorways other than the system palette
; colour info is already in regs d0-d3

; on entry				  on exit

; d0 = paper colour		  preserved
; d1 = border /items selected colour	  preserved
; d2 = ink colour			  preserved
; d3 = menu title block colour		  preserved
; d4 = number ow window with title bar (or -1 if none) preserved
; a3 = window definition (not working defn)	  preserved
; all other regs reserved, condition codes set on exit

make_col2
	movem.l myregs2,-(a7)
comm	movem.l d0-d2,-(a7)
	moveq	#$10,d0
	moveq	#-1,d1
	moveq	#-1,d2

	trap	#1			; read colours
	move.l	d1,d5
	movem.l (a7)+,d0-d2

	move.w	d2,$c(a3)		; border col (for main window=ink col)
	move.w	d0,$e(a3)		; paper col

	move.w	d2,$14(a3)		; current item border col

	move.w	d0,$16(a3)		; now item attributes
	move.w	d1,$18(a3)		; unavailable

	move.w	d0,$1e(a3)
	move.w	d2,$20(a3)		; available

	cmp.b	#2,d5
	beq.s	is_mono
	move.w	d1,$26(a3)
	move.w	d2,$28(a3)		; selected item if colour screen
	bra.s	all_cols
is_mono move.w	d2,$26(a3)
	move.w	d0,$28(a3)		; selected if mono

all_cols
	lea	$30(a3),a3		; now point to repeated part
cont	addq.l	#4,a3			; point to info subwindow defn list
	move.w	(a3),d5
	beq.s	end_infos		; do nothing if no info windows
	move.l	a3,a0
	add.w	d5,a0			; a0 points to info list now
	moveq	#0,d5
do_infos
	tst.w	(a0)			; is it end of info windows?
	blt.s	end_infos		; yes->...
	lea	$c(a0),a0
	move.w	d1,(a0)+		; border colour of this info window
	btst	d5,d4			; is this window with title bar?
	beq.s	no_tit			; no->...
	move.w	d3,(a0)+		; paper colour of window with the bar
	bra.s	infcom

no_tit	move.w	d0,(a0)+		; paper colour of this normalinfo window

infcom	move.w	(a0),d6 		; any objects?
	beq.s	no_objs 		; no->...
	move.l	a0,a1
	add.w	d6,a1			; a1 points to info objects for this iw
do_objs tst.w	(a1)			; is it end of objects?
	blt.s	no_objs 		; yes->...
	tst.b	8(a1)			; is object text?
	bgt.s	no_text 		; no->...
	move.w	d2,$a(a1)		; set text colour
no_text lea	$10(a1),a1		; point to next object
	bra.s	do_objs 		; and go round again
no_objs addq.l	#2,a0
	addq.w	#1,d5
	bra.s	do_infos
end_infos
	addq.l	#6,a3			; point to next possible defn
	tst.w	(a3)			; anything there?
	bge.s	cont			; yes->...
	moveq	#0,d0			; set condition codes
make_out
	tst.l	d0
	movem.l (a7)+,myregs2
	rts


; make_col3
; this makes the colours for an menu appsub working defn
; on entry					exit
; d0-d3 ???					d0 paper col, d2 "ink" col
; a1 = pointer to colour byte		preserved
; a3 = pointer to appsub working defn		preserved
; all regs (including d0) reserved, condition codes set on exit

	xdef	  make_col3
myaregs  reg	     d1/d3-d6/a0/a1/a3
make_col3
	movem.l myaregs,-(a7)
	cmp.b	#4,(a1) 		; sys palette?
	bge.s	appsyspal		; yes
	bsr	mk_col			; get cols into d0-d3
	bne.s	make_out

	move.w	d1,wwa_watt+wwa_borc(a3); border col (for appsub window)
	move.w	d0,wwa_watt+wwa_papr(a3); paper col
	tst.w	wwa_nxsc(a3)		; any x section?
	beq.s	ysect2			;  ... no
	move.w	d0,wwa_psbc(a3) 	; scroll bar colour
	move.w	d2,wwa_pssc(a3) 	; scroll bar section colour
	move.w	d1,wwa_psac(a3) 	; scroll arrow colour
ysect2	tst.w	wwa_nysc(a3)		; any y section?
	beq.s	items			; ...no
	move.w	d0,wwa_psbc+wwa.clen(a3); scroll bar colour
	move.w	d2,wwa_pssc+wwa.clen(a3); scroll bar section colour
	move.w	d1,wwa_psac+wwa.clen(a3); scroll arrow colour
items
	move.w	#1,wwa_curw+wwa_iatt(a3); curent item border width
	move.w	d2,wwa_curc+wwa_iatt(a3); curent item border colour
	move.w	d0,wwa_back+wwa_attr+wwa_iatt(a3)
	move.w	d1,wwa_ink+wwa_attr+wwa_iatt(a3)
	move.w	d0,wwa_back+wwa_aval+wwa_iatt(a3)
	move.w	d2,wwa_ink+wwa_aval+wwa_iatt(a3)
	move.w	d1,wwa_back+wwa_selc+wwa_iatt(a3)
	move.w	d2,wwa_ink+wwa_selc+wwa_iatt(a3)
	moveq	#0,d6
	movem.l (a7)+,myaregs
	rts

appsyspal
	move.w	#sp.appbd,wwa_watt+wwa_borc(a3) ; border col (for appsub window)
	move.w	#sp.appbg,wwa_watt+wwa_papr(a3) ; paper col
	tst.w	wwa_nxsc(a3)			; any x section?
	beq.s	ysect				;  ... no
	move.w	#sp.scrbar,wwa_psbc(a3) 	; scroll bar colour
	move.w	#sp.scrbarsec,wwa_pssc(a3)	; scroll bar section colour
	move.w	#sp.scrbararr,wwa_psac(a3)	; scroll arrow colour
ysect	tst.w	wwa_nysc(a3)			; any y section?
	beq.s	items2				; ...no
	move.w	#sp.scrbar,wwa_psbc+wwa.clen(a3)    ; scroll bar colour
	move.w	#sp.scrbarsec,wwa_pssc+wwa.clen(a3) ; scroll bar section colour
	move.w	#sp.scrbararr,wwa_psac+wwa.clen(a3) ; scroll arrow colour
items2
	move.w	#1,wwa_curw+wwa_iatt(a3)	    ; curent item border width
	move.w	#sp.appihigh,wwa_curc+wwa_iatt(a3)  ; curent item border colour
	move.w	#sp.appiavabg,wwa_back+wwa_aval+wwa_iatt(a3)  ; curent item border colour
	move.w	#sp.appiavafg,wwa_ink+wwa_aval+wwa_iatt(a3)  ; curent item border colour
	move.w	#sp.appiselbg,wwa_back+wwa_selc+wwa_iatt(a3)  ; curent item border colour
	move.w	#sp.appiselfg,wwa_ink+wwa_selc+wwa_iatt(a3)  ; curent item border colour
	move.w	#sp.appiunafg,wwa_ink+wwa_attr+wwa_iatt(a3)  ; curent item border colour
	move.w	#sp.appiunabg,wwa_back+wwa_attr+wwa_iatt(a3)  ; curent item border colour
	move.w	#sp.appbg,d0			; appsub paper colour
	move.w	#sp.appiavafg,d2		; appsub "ink" colour
	moveq	#0,d6
	movem.l (a7)+,myaregs
	rts

*****************************************************************************
; chk_col
; this checks the colourway indicated by a byte pointed to by (a1)
; on entry : a1 = pointer to colourways byte with the following values:
;  =-1		: get menu extensions default colourway
;  = 0 - 3	: pre 16-bit wman colourways
;  = 4 -7	: use system palette 0- 3
; 1 - if this is set to 4+ (syspal) and the system can't handle a syspal
;    (i.e wman too old) then this byte is set to 0 (colourway 0) !
; 2 - if the byte is set to -1
;   then it is replaced (!) by the corresponding menu extn default colourway
;   but if there are no menu extns, then this is set to 0!
; in cases 1 and 2, whatever happens, there is no error given back
; the routine succeeded
;
; on entry
; d0.b = window indicator :			exit
;   = 0 - colourway for main wdw		error code (no pointer if!)
;   = 1 - colourway is for sub
;   = 2 - colourway is for button
; a0 = channel id
; a1 = ptr to colourway wished (.b)
; all regs preserved, d0 = possible error code
*****************************************************************************
	xref	mu_getdef	; in dev1_asm_lib_get_menu_defcols_asm
	xdef	chk_col

colregs reg	d0-d4/a1/a2
chk_col movem.l colregs,-(sp)	; keep
	move.w	d0,d4		; key
	move.b	(a1),d0 	; colourway
	bge.s	no_default	; no need to get default colours from menus
	jsr	mu_getdef	; try to get menu extns defaults
	beq.s	def_ok		; ... got them ok->...
	move.b	#0,(a1) 	; error in menu extns - use colway 0...
	bra.s	no_check	; ...and simulate no error
def_ok	move.b	d1,d0		; colourway for main wdw
	tst.b	d4		; get key for main wdw?
	beq.s	do_default	; ...yes
	move.w	d2,d0		; colway for sub wdw
	subq.b	#1,d4		; it is subwindow ?
	beq.s	do_default	; yes
	move.b	d3,d0		; no, colway for button
do_default
	move.b	d0,(a1)
no_default
	subq.b	#4,d0		; is colourway syspal?
	blt.s	no_check	; no, so this is ok!
	move.l	a1,a2		; keep pointer to colourway byte
	moveq	#$70,d0
	moveq	#-1,d3
	trap	#3		; get pi info
	tst.l	d0
	bne.s	chk_out 	; oops
	cmp.l	#'1.74',d1	; valid wman?
	bge.s	no_check	; ... yes
	move.b	#0,(a2) 	; ... no, set to colourway 0!
no_check moveq	 #0,d0		; no error!
chk_out  movem.l (sp)+,colregs
	rts
	end
