; error routines for wined
; v. 1.02	1994 sep 14 11:36:39
;  w. lenerz 1994 -2018

	section action
	include dev1_asm_wined_includes
	include DEV8_keys_wman
	include DEV8_keys_wwork

	xdef	read_error
	xdef	write_error
	xdef	badpar_error
	xdef	file_err
	xdef	warning

	xref	warn_tit		;
	xref	colw
	xref	err_read
	xref	err_wrt
	xref	bpm
	xref	file_tit

	xref	do_dorp 	; do 'dorp' menu extension

;---------------------------------------------------------
; this shows the error and a possible message.
; it waits for the user to press a key
; entry 			exit
; d0 error
; a1 pointer to error message	corr
; (-> 'warning' routine  only)
; all other regs preserved
;----------------------------------------------------------

errregs reg	d1-d3/d7/a0/a2-a3

warning movem.l errregs,-(a7)
	lea	warn_tit,a0
	moveq	#0,d0
	move.l	d0,d1
	move.w	(a1),d1 	; max length of string
	move.w	d1,d7		; keep for later
	bra.s	errcom

badpar_error
	lea	bpm,a1
	bra.s	warning
read_error
	lea	err_read,a1
	bra.s	file_err

write_error
	lea	err_wrt,a1

file_err
	movem.l errregs,-(a7)
	lea	drivetxt(a4),a0
	cmp.w	#filedit,type(a4)
	bne.s	ok1
	lea	fname_sp(a4),a0
ok1	move.l	a1,a3
	moveq	#0,d1
	move.w	(a3)+,d1
	move.w	d1,d7		; keep old length of string
	beq.s	endloop
	add.w	d1,a3		; a3 points to last char of this text
	move.w	(a0)+,d2
	beq.s	endloop
	add.w	d2,d1
	addq.w	#1,d1
	move.w	d1,(a1) 	; length of string
	subq.w	#1,d2
loop	move.b	(a0)+,(a3)+	; copy device name to error message
	dbf	d2,loop
	move.b	#':',(a3)	; add ':'
	addq.w	#2,d1
endloop lea	file_tit,a0	; title
errcom	lea	err(a4),a6
	move.l	d0,(a6)
	lea	colw,a2
	moveq	#0,d3
	move.b	(a2),d3 	; colourways
	cmp.w	#40,d1
	bge.s	dont_set
	moveq	#40,d1		; minimum window length
dont_set
	bchg	#0,d3		; make sure it stands out
	move.l	#winpos,d2	; x,y positions
	lea	actrout,a2	; fake action routine
	move.l	a1,a3
	jsr	do_dorp 	; do a fake dorp menu
	move.w	d7,(a3) 	; reinstate old length of string
	movem.l (a7)+,errregs
	tst.l	d0		; should always be ok
	rts

actrout move.l	(a6),d0 	; "error" or not
	bne.s	no_str
	sub.l	a1,a1
no_str	rts

	end
