; getsecnbr for Wined
; this gets a sector number and tries to set the file position to this
; returns 0 if ok
; else file error. if position can't be set, sector(a4) is not changed
; v. 1.07		2003 Jun 06 09:23:20
;  W. Lenerz 1994 - 2018

	section set_sectnbr

	xdef	get_secnbr
	xdef	mksecascii	;

	xref	colw			; colourway
	xref	getsecpt		; prompt
	xref	getsectit		; title
	xref	getblkpt		; prompt
	xref	getblktit		; title

	xref	transa1toa0		; transfers string from (a1) to (a0) (lib)
	xref	ai_to_l 		; ascii integer to signed long word (gu)
	xref	do_rstr 		; does read string me (lib_menus_rstr)
	xref	read_sec		; sets file position & reads (wined_gu)
	xref	cvtlong 		; converts long to decimal ascii
	xref	ltoahex 		; converts long to hex ascii (gu_ltoahex)
	xref	read_error		; print error message (wined_filerr)
	xref	make_hex
	xref	nbr_sects		; text with f5... for win
	xref	block			; text with f5... for file
	xref	warning 		; print err msg (wined_filerr)

	xref	calc_sec		; calculates sector for floppy (wined_gu)
	xref	rest_old		; (wined_gu)

	xref	wintype 		; type of win drive (0=miracle,1=qub)
					; (wined_cfg)


	include dev8_keys_k		; keyboard keys
	include dev1_asm_wined_includes
	include DEV8_keys_qdos_io


myregs	reg	d1-d3/a0-a3
charoff equ	12			; charoff for new string

;	entry				exit
; d4.b					<>0 if offset into block (file edit)

get_secnbr
	movem.l myregs,-(a7)
	clr.l	d4
	move.w	type(a4),d0
	cmp.w	#flodisk,d0		; do we edit floppy disk?
	beq	getfl_dat		; yes->...
	cmp.w	#winedit,d0		; else; is it win?
	bne.s	simpl_sec		; no->...
	lea	wintype,a1		; what type of win?
	tst.b	(a1)			; is it qubide?
	bne	getfl_dat		; yes->...
simpl_sec lea	secnb3(a4),a1		; point to place for string
	move.l	sector(a4),d1
	move.l	#$500050,d2		; cursor position
	lea	colw,a2
	moveq	#0,d3
	move.b	(a2),d3 		; colourway
	cmp.w	#filedit,type(a4)	; editing a file?
	beq.s	getf			; yes->...
winf	jsr	ltoahex 		; transform into hex now
	lea	getsectit,a0		; title
	move.l	a1,a2			; point to default
	lea	getsecpt,a3		; prompt
	moveq	#40,d1			; max number of chars & cursor at front
	jsr	do_rstr 		; get string with number
	blt.s	gs_out			; ooops
	bgt.s	esc_noch		; if esc, just leave
	bsr	make_int		; make into (long) integer
	bne.s	gs_out			; hey!
	moveq	#0,d4			; never any "offset" for floppy, win
is_win	move.l	sector(a4),d1		; keep old sector number
	move.l	d2,sector(a4)
	movem.l d1/a1,-(a7)
	bsr	read_sec		; try to set position now
	movem.l (a7)+,d1/a1		; get my regs back
	beq.s	ok			; read sector was OK?
	move.l	d1,sector(a4)		; no, reset old position!
	bsr	read_error		; show error
	bra.s	gs_out			; and leave
ok	bsr.s	mksecascii		; set new string now
gs_out	movem.l (a7)+,myregs
	tst.l	d0
	rts

esc_noch
	moveq	#0,d0			; no error
	bra.s	gs_out

; we're editing a file
getf	lsr.l	#8,d1
	lsr.l	#1,d1
	jsr	ltoahex 		; transform into hex now
	lea	getblktit,a0		; title
	move.l	a1,a2			; point to default
	lea	getblkpt,a3		; prompt
	moveq	#40,d1			; max number of chars & cursor at front
	jsr	do_rstr
	blt.s	gs_out			; if problem
	bgt.s	esc_noch		; if esc, just leave
	lea	secnb3(a4),a1
	moveq	#-15,d0 		; preset error
	moveq	#0,d4			; preset flag: no hash
	move.w	(a1)+,d3		; length into d3
	beq.s	gs_out			; must not be 0 string
	cmp.b	#'#',(a1)		; was string preceded by hash?
	bne.s	no_hash 		; no, so go on
	subq.w	#1,d3			; new length
	beq.s	gs_out			; must be more than 0
	addq.l	#1,a1			; point past byte '#'
	moveq	#-1,d4			; show that hash is used
no_hash bsr	mkint2			; get new number into d2
	bne.s	gs_out			; ooops
	trap	#14
	tst.w	d4			; was it hash?
	beq.s	no_hash2		; no->...
	clr.l	d4
	move.b	d2,d4			; keep offset within block
	andi.b	#0,d2			; yes, so this is offset into file
	bra.s	is_win
no_hash2
	lsl.l	#8,d2
	lsl.l	#1,d2			; * 512
	clr.l	d4
	bra   is_win



; this resets the string for the "f5 -sector..." item

mkscregs  reg	d0-d5/a0-a2
mksecascii
	movem.l mkscregs,-(a7)
	move.w	type(a4),d0
	lea	nbr_sects,a0		; preset for win
	move.l	sector(a4),d1
	subq.w	#1,d0			; is it win ?
	bne.s	flp1			; no->...
	lea	wintype,a1
	tst.b	(a1)			; is it miracle or qubide?
	beq.s	winorfile		; miracle->...
	moveq	#-1,d5			; show that this is qubide
	bra.s	do_floppy		; if qubide->...
flp1	moveq	#0,d5			; preset floppy
	subq.w	#1,d0			; is it floppy ?
	beq.s	do_floppy		; yes->...
	lea	block,a0		; no; so it must be file
	lsr.l	#8,d1
	lsr.l	#1,d1
winorfile lea	secnb3(a4),a1		; point to place for string
	jsr	ltoahex 		;  transform into hex now
	lea	secnb(a4),a2
	move.w	(a0)+,d0
	move.w	(a1)+,d1
	move.w	d0,d2
	add.w	d1,d2
	move.w	d2,(a2)+
	add.w	d0,a2
	subq.w	#1,d1
msloop2 move.b	(a1)+,(a2)+
	dbf	d1,msloop2
msout	moveq	#0,d0
	movem.l (a7)+,mkscregs
	rts

do_floppy lea	secnb+2(a4),a2	; a2 points to f5... string now

do_side move.w	side(a4),d1
	move.b	d1,d2
	add.b	#'0',d1
	cmp.b	#'9',d1
	bls.s	ok5
	addq.b	#7,d1
ok5	move.b	d1,sp_side(a2)
	lsr.w	#4,d2
	andi.b	#$f,d2
	add.b	#'0',d2
	cmp.b	#'9',d2
	bls.s	ok6
	addq.b	#7,d2
ok6	move.b	d2,sp_side-1(a2)
	move.w	track(a4),d1
	move.w	d1,d2
	andi.b	#$f,d1
	add.b	#'0',d1
	cmp.b	#'9',d1
	bls.s	ok1
	addq.b	#7,d1
ok1	move.b	d1,sp_trk(a2)
	lsr.w	#4,d2
	andi.b	#$f,d2
	add.b	#'0',d2
	cmp.b	#'9',d2
	bls.s	ok2
	addq.b	#7,d2
ok2	move.b	d2,sp_trk-1(a2)
	tst.b	d5		; is it floppy or qubide drive?
	beq.s	is_flop 	; if floppy ->...
	lsr.w	#8,d2		; get upper byte of word into lower byte
	andi.b	#$f,d2
	add.b	#'0',d2
	cmp.b	#'9',d2
	bls.s	ok7
	addq.b	#7,d2
ok7	move.b	d2,sp_trk-2(a2)

is_flop move.w	fl_sect(a4),d1
	move.b	d1,d2
	andi.b	#$f,d1
	add.b	#'0',d1
	cmp.b	#'9',d1
	bls.s	ok3
	addq.b	#7,d1
ok3	move.b	d1,sp_sect(a2)
	move.b	d2,d1
	lsr.w	#4,d1
	andi.b	#$f,d1
	add.b	#'0',d1
	cmp.b	#'9',d1
	bls.s	ok4
	addq.b	#7,d1
ok4	move.b	d1,sp_sect-1(a2)
	bra	msout

make_int	lea	secnb3(a4),a1
	move.w	(a1)+,d3
	beq.s	error
mkint2	cmp.b	#'$',(a1)
	bne.s	no_dol
	subq.w	#1,d3
	beq.s	error
	addq.l	#1,a1
no_dol	moveq	#0,d2
	subq.w	#1,d3
loop	move.b	(a1)+,d1
	bsr	make_hex
	bne.s	mi_out
	rol.l	#4,d2
	or.b	d1,d2
	dbf	d3,loop
	moveq	#0,d0
mi_out	rts

error	moveq	#-15,d0
	rts


getfl_dat lea	more_sp(a4),a3
	move.l	side(a4),(a3)+		; stock the old values somewhere
	move.w	fl_sect(a4),(a3)
	moveq	#0,d2
	bne	gs_out
	moveq	#it_sec,d1		; this is the item concerned (f5-..)
	jsr	$5c(a5) 		; set window to this item
	moveq	#-1,d3
	moveq	#$20,d0
	trap	#3			; cls
	lea	secnb(a4),a1
	move.w	(a1)+,d2		; current position
	moveq	#7,d0
	trap	#3			; print the current position
	moveq	#$e,d0
	trap	#3
; now get the side
get_side	moveq	#sp_side-1,d5	  ; cursor position
	move.l	maxsides(a4),d4
	clr.w	d4			; d4=max | min
	lea	side(a4),a3		; point to where this is put
	bsr	getchar 		; get a char and put it in
	cmp.b	#$10,d1 		; was it enter?
	beq.s	test_pos		; yes, so do not set the rest

; now get the track
get_trk cmp.w	#flodisk,type(a4)	; is it floppy?
	beq.s	do_flop 	; yes->...
	moveq	#0,d4
	move.b	track(a4),d7	; upper byte now
	move.w	maxtrack(a4),d4
	lsr.w	#8,d4		; get rid of lower byte
	swap	d4		; higest|lowest
	bset	#31,d4		; show that we only want one byte
	moveq	#sp_trk-2,d5	; new cursor position
	bsr	getchar2


do_flop moveq	#sp_trk-1,d5	; new cursor position
	move.l	maxtrack(a4),d4 ; cannot exceed this
	clr.w	d4		; this is minimum
	lea	track(a4),a3
	bsr.s	getchar
	cmp.b	#k.left,d1
	beq.s	get_side
	cmp.b	#$10,d1
	beq.s	test_pos

sectorr moveq	#sp_sect-1,d5
	move.l	maxsect(a4),d4
	cmp.w	#flodisk,type(a4)	; are we editing floppy?
	beq.s	is_flp		; yes
	clr.w	d4		; no, so min sector=0
	bra.s	iok
is_flp	move.w	#1,d4		; minimum sector
iok	lea	fl_sect(a4),a3
	bsr.s	getchar
	cmp.b	#k.left,d1	; was it go left?
	beq.s	get_trk 	; yes

test_pos	moveq	#$f,d0
	trap	#3		; disable cursor
	move.l	sector(a4),d4
	jsr	calc_sec
	move.l	d1,sector(a4)
	movem.l d4/a1,-(a7)
	bsr	read_sec		; try to set position now
	movem.l (a7)+,d4/a1	;
	beq.s	fl_ok		; did positioning work ok? yes->...
	move.l	d4,sector(a4)	; old sector position
	jsr	read_error	; show the read error
	jsr	rest_old		; restore old position
	bra.s	gs_end
fl_ok	bsr	mksecascii	; set new string now
gs_end	movem.l (a7)+,myregs
	moveq	#0,d0
	rts

; this gets 2 hex chars forone byte : it first gets the upper nibble
; then the lower one
; on entry:

; a3   = place to put word (!!!), the byte is at offset #1 off there
;		  ----
; d4.l = maximum | minimum of this char to get
;	bit #31 of d4 is set if we only want to get one char
; d5   = cursor position to set
; d7   = byte up to now

; in routine
; d4= maximum | minimum of this char to get
;	bit #31 of d4 is set if we only want to get one char
; d7= byte so far
; d6= max of nibble
; d5= min of nibble
get_pchar tst.l d4
	blt.s	getchar2
	subq.w	#1,d5
getchar move.b	1(a3),d7
gs2	move.l	d5,d1
	moveq	#$11,d0
	trap	#3		; set cursor pos
gcloop	moveq	#1,d0
	trap	#3		; get a byte
	cmp.b	#10,d1		; was it enter?
	beq	gc_out		; yes, so just leave->...
	cmp.b	#k.left,d1
	beq	gc_out
	cmp.b	#k.right,d1
	beq	gc_out
	moveq	#0,d2		; make sure this is empty
	move.b	d1,d2		; keep this byte
	moveq	#5,d0
	trap	#3		; print this byte
	moveq	#0,d1
	subi.b	#'0',d2 	; make into number
	cmp.b	#9,d2		; if a-f, make into number
	ble.s	noascii
	bclr	#5,d2
	subi.b	#7,d2
noascii cmp.b	#$f,d2
	bhi.s	getchar
	move.b	d2,d6		; keep for the time being
	move.b	d4,d1		; minimum into d6
	lsr.b	#4,d1		; eliminate lower nibble
	sub.b	d1,d2		; must be at least this much
	blt.s	getchar

	swap	d4
	move.b	d4,d1
	swap	d4

	move.b	d6,d2
	lsr.b	#4,d1
	sub.b	d2,d1		; but must not exceed maximum either
	blt.s	getchar 	;
	lsl.b	#4,d6		; put into upper nibble
	andi.b	#$f,d7		; get rid of old upper nibble
	add.b	d6,d7		; put in into upper nibble now
get_nchar addq.w	#1,d5		; new cursor position
getchar2	move.l	d5,d1
	moveq	#$11,d0
	trap	#3		; set cursor pos
	moveq	#1,d0
	trap	#3		; get a byte
	cmp.b	#10,d1		; was it enter?
	beq.s	io3		; yes, so just leave->...
	cmp.b	#k.left,d1
	beq	get_pchar
	cmp.b	#k.right,d1
	beq.s	io3
	moveq	#0,d2		; make sure this is empty
	move.b	d1,d2		; keep this byte
	moveq	#5,d0
	trap	#3		; print this byte
	moveq	#0,d1
	subi.b	#'0',d2 	; make into number
	cmp.b	#9,d2		; if a-f, make into number
	ble.s	noascii2
	bclr	#5,d2
	subi.b	#7,d2
noascii2	cmp.b	#$f,d2
	bhi.s	getchar2
	andi.b	#$f0,d7
	add.b	d2,d7		; add lower nibble now
io3	move.b	d7,d2		; keep for the time being
	move.b	d4,d6		; lesser limit
	cmp.b	d2,d6
	bhi.s	getchar2
	swap	d4
	move.b	d4,d6		; maximum into d6
	swap	d4
	move.b	d7,d2
	cmp.b	d6,d2		; must be at least this much
	bhi.s	getchar2
gc_out	move.b	d7,1(a3)		 ; if ok, put into place
	moveq	#0,d0
	rts
			  

	end
