; RDRWINFO for WINED
; this changes the menu name according to what we have
; also the 'drive item'
; v. 1.07	1995 Sep 24 11:36:20
;  W. Lenerz 1994 - 2018

	section rdraw

	xdef	rdrwinfo
	xdef	set_drive
	xdef	set_sec 	; sets the sector info

	xref	mksecascii

	xref	tit_str 	; hard disk title (wined_english)
	xref	floppytit	; floppy disk title (wined_english)
	xref	windrive
	xref	flop
	xref	redraw		; redraws items
	xref	block		; f5 text for file editor
	xref	nbr_sects	; f5 text for win editor
	xref	sps		; f5 text for flp editor
	xref	qub		;  "   "	  " qubide win editor
	xref	wintype 	; config item

	include dev8_keys_wstatus
	include dev8_keys_wwork
	include dev1_asm_wined_includes

; this changes the tile of the window
; (hard disk sector editor, floppy sector editor etc...)

myregs	reg	d1-d3/a0-a2

; first we copy the new name into the buffer set up for this
rdrwinfo
	movem.l myregs,-(a7)
	move.w	type(a4),d0	; what type are we editing now?
	subq.w	#1,d0		; is is hard disk?
	bne.s	floppy		; no->...
	lea	tit_str,a1	; yes, so this is our title
	bra.s	rdcom
floppy	subq.w	#1,d0
	bne.s	file
	lea	floppytit,a1	; if floppy, get title
	bra.s	rdcom
file	lea	fname_sp(a4),a1 ; if file: get filename
rdcom	lea	name(a4),a2	;
	move.l	a2,-(a7)
	move.w	(a1)+,d0		; length of name
	moveq	#0,d1
	move.w	d0,d1		; keep it for later
	move.w	d0,(a2)+
	subq.w	#1,d0
rdloop1 move.b	(a1)+,(a2)+
	dbf	d0,rdloop1	; copy name now
	move.l	(a7)+,a2
; now make new length of this info window and object
; first, point to this info window (which is the third in the list)
	move.l	ww_pinfo(a4),a1 ; point to start of info window lists
	move.l	a1,a3
	moveq	#wwi.elen,d0	; length of 1 entry in list
	lsl.w	#1,d0		; *2 (third entry)
	add.l	d0,a1		; a1 is now our info window
	mulu	#6,d1
	addq.w	#4,d1		; d1 is length of our window
	move.w	d1,wwi_xsiz(a1) ; put length in
	move.w	#xsize,d0	; window x size
	sub.w	d1,d0		; minus length of window...
	lsr.w	#1,d0		; .../2 = origin of window
	move.w	d0,wwi_xorg(a1)
	move.l	wwi_pobl(a1),a1 ; now point to the object list#
	subq.w	#4,d1		; new length
	move.w	d1,wwo_xsiz(a1) ; into object now
	move.l	a2,wwo_pobj(a1) ; point to object now

; now we redraw the two info windows (i.e. this one & the menu bar)

	moveq	#-6,d3
	jsr	$3c(a5) 	; redraw windows now

; now we do the 'drive 'item and the f5 item
	bsr.s	set_drive	; set "drive" item (and special file)
	bsr	set_sec 	; copy name of f5 item
	jsr	mksecascii	; fills in sector data into f5 item
	movem.l (a7)+,myregs
	jmp	redraw		; redraw items and return


; set drive
; this copies the new name of the drive into the space for the "drive" item,
; and also sets up the name of the special file (e.g. win1_*d2d)
;
mreg	reg	d2-d3/a0-a3
set_drive
	movem.l mreg,-(a7)
	lea	drivetxt(a4),a2 ; point to text device name
	lea	specfile(a4),a1 ; name of special file to open
	move.w	#0,(a2) 	; show no drive yet (!)
	moveq	#9,d3		; preset length of file name
	lea	windrive+2,a3	; now copy default drive across
	move.w	type(a4),d0	; default type of device we are editing
	subq.w	#1,d0		; is it win?
	beq.s	is_win		; yes ->...
	subq.w	#1,d0		; is it floppy?
	bne.s	do_secout	; no ->...

is_floppy
	lea	flop+2,a3	; yes, load floppy name
	bsr.s	copy_name	; copy first part of name
	move.l	#'_*D2',6(a1)
; added for dd,hd
	move.w	ftype(a4),d0	; what type of disk? (0=dd, 1=hd)
	beq.s	is_dd		; is dd
	subq.w	#1,d0
	beq.s	is_hd
	move.b	#'4',9(a1)
	move.b	#'E',10(a1)
	bra.s	dd_hd_all
is_hd	move.b	#'H',10(a1)	; else is hd, so show type of disk
	bra.s	dd_hd_all
is_dd	move.b	#'D',10(a1)
	bra.s	dd_hd_all

is_win	bsr.s	copy_name
	lea	wintype,a0	; contains type of drive (0=mir,1=qubi)
	tst.b	(a0)		; what type of drive is it?
	bne.s	is_qu		; if qubide->...
	move.l	#'_*D2',6(a1)	; if miracle, add '_*d2d' to dive
	move.b	#'D',10(a1)
	bra.s	dd_hd_all

is_qu	move.l	#'_*WL',6(a1)
	moveq	#7,d3		; length of filename
dd_hd_all
	move.w	d3,(a1) 	; set length of file
	move.w	#5,(a2) 	; set length of device
	move.b	#'_',6(a2)
	moveq	#it_drv,d0	; show that item must be redrawn
do_com	move.l	(a4),a1
	move.b	#1,$40(a1,d0.w)
do_secout
	moveq	#0,d0
	movem.l (a7)+,mreg
	rts

copy_name
	move.l	(a3)+,d0
	move.w	drive(a4),d1
	add.b	#'0',d1
	move.b	d1,d0
	move.l	d0,2(a2)		; copy into drive text item space
	move.l	d0,2(a1)		; copy into special file name space
	rts

; set_sec
; this copies the name into the f5 item
set_sec movem.l mreg,-(a7)
	lea	secnb(a4),a2		;  place to copy to: text for info wdw
	lea	nbr_sects,a1		; preset win: place to copy from
	move.w	type(a4),d0
	subq.w	#1,d0			; is it win ?
	bne.s	see_floppy		; no ->...
	lea	wintype,a0
	tst.b	(a0)			; what type of drive is it?
	beq.s	cpy_name		; normal win->...
	lea	qub,a1
cpy_name
	move.w	(a1)+,d0		; copy this
	move.w	d0,(a2)+
	subq.w	#1,d0
cpy_lp1 move.b	(a1)+,(a2)+
	dbf	d0,cpy_lp1		; copy name
	moveq	#it_sec,d0
	bra.s	do_com			; reset regs & leave
see_floppy
	lea  block,a1			; preset file
	subq.w	#1,d0			; is it floppy
	bne.s	cpy_name
	lea	sps,a1
	bra.s	cpy_name

	end
