; Save/append sector for WINED
; v. 1.02	2003 May 08 13:26:59
;  W. Lenerz 1994 - 2018


	section file

	xdef	save_file
	xdef	append
	include dev1_asm_wined_includes

	xref	filtpmpt		; prompt for filename
	xref	filetit 	; title for window
	xref	input_str	; uses rstr menu to gets string (wined_gu)
	xref	do_ferr 	; does ferr menu extension (lib_menus)
	xref	colw		; colourways byte (main)
	xref	do_fsel 	; does fsel menu extension (lib_menus)

;-------------------------------------------------------------------------
; save_file
; entry 			exit
; d0				0 or error
; d1				corr
; d2				corr
; d3				corr
  
; condition codes set on exit
;-------------------------------------------------------------------------
sfregs	reg	d4/a0-a3
save_file
	movem.l sfregs,-(a7)
bigloop lea	fname_sp(a4),a1 ; point to space now
	lea	filetit,a0
	lea	filtpmpt,a3
	bsr	input_str
again	moveq	#2,d3		; open new exlusive
op_file lea	fname_sp(a4),a0
	moveq	#-1,d1
	moveq	#1,d0
	trap	#2		; open file
	tst.l	d0
	bne.s	err_file
	moveq	#-1,d3
apsavcom
	move.w	endofile(a4),d0
	bne.s	apsavcom2
	moveq	#0,d0
	move.w	seclen(a4),d0
apsavcom2
	move.l	d0,d2
	moveq	#7,d0
	lea	file_sp(a4),a1
	trap	#3		; save to file
	move.l	d0,-(a7)		; keep error
	moveq	#2,d0
	trap	#2		; close file
	move.l	(a7)+,d0
save_out
	movem.l (a7)+,sfregs
	tst.l	d0		; return with error
	rts

err_file
	move.l	d0,d1
	move.l	#winpos,d2
	move.l	#$ffff,d3
	swap	d3
	lea	colw,a1
	move.b	(a1),d3
	jsr	do_ferr
	tst.l	d0
	bne.s	save_out
	tst.w	d1
	ble.s	save_out
	cmp.b	#3,d1
	beq.s	bigloop
	cmp.b	#1,d1
	beq.s	again
	moveq	#3,d3
	cmp.w	#2,d1
	beq.s	op_file
	bra.s	save_out


;-------------------------------------------------------------------------
; append to file
; entry 			exit
; d0				0 or error
; d1				corr
; d2				corr
; d3				corr
  
; condition codes set on exit
;-------------------------------------------------------------------------
	section append

	xdef	append
	xref	appendtit
	xref	do_fsel 	; does fsel menu extension (lib_menus)


append	movem.l sfregs,-(a7)
	moveq	#0,d1
	moveq	#0,d3
	lea	colw,a1
	move.b	(a1),d3
	swap	d3
;	 lea	 colwa,a1
	move.b	(a1),d3
	moveq	#0,d2
	moveq	#0,d4
	lea	fname_sp(a4),a1
	sub.l	a3,a3
	move.l	a1,a2
	lea	appendtit,a0
	jsr	do_fsel
	bne	save_out
	lea	fname_sp(a4),a0
	moveq	#0,d3		; open old exclusive key
	moveq	#-1,d1		; i'm owner
	moveq	#1,d0		; open file key
	trap	#2		; open old exclusive
	tst.l	d0		; does file exist
	bne	again		; no, so do a normal save
	moveq	#-1,d3
	move.l	#$effffff,d1
	moveq	#$42,d0
	trap	#3		; set file position
	cmp.l	#-10,d0 	; must have been eof
	bne	save_out
	bra	apsavcom

	END
